<id>
Member Specific Permissions
</id>

<version>
1.31
</version>

<mod info>
This mod allows you to define permissions specific to a member

CREATE TABLE `cvs_member_permissions` ( 
`ID_BOARD` smallint(5) NOT NULL default '-1', 
`permission` varchar(24) NOT NULL default '', 
`addDeny` tinyint(4) NOT NULL default '1', 
`ID_MEMBER` int(11) NOT NULL default '-1', 
PRIMARY KEY (`ID_BOARD`,`permission`) ) TYPE=MyISAM; 

</mod info>

<author>
Grudge
</author>

<homepage>
www.mymods.co.uk
</homepage>

<edit file>
$sourcedir/Security.php
</edit file>

<search for>
	return array_values(array_diff($boards, $deny_boards));
</search for>

<add before>
	// Handle member specific permissions - for local boards.
	$request = db_query("
		SELECT ID_BOARD, addDeny
		FROM {$db_prefix}member_permissions
		WHERE ID_MEMBER = $ID_MEMBER
			AND ID_BOARD != 0
			AND permission = '$permission'
		ORDER BY addDeny DESC, ID_BOARD", __FILE__, __LINE__);
	// This is used to override denys!
	$remove = array();
	while ($row = mysql_fetch_assoc($request))
	{
		if (empty($row['addDeny']))
			$deny_boards[] = $row['ID_BOARD'];
		else
		{
			$boards[] = $row['ID_BOARD'];
			// Member permissions override even a Deny!
			$remove = array_merge(array_keys($deny_boards, $row['ID_BOARD']), $remove);
		}
	}
	mysql_free_result($request);
	foreach ($remove as $key)
		unset($deny_boards[$key]);
</add before>

<search for>
		SELECT b.ID_BOARD, IFNULL(bp.addDeny, mod_bp.addDeny) AS addDeny
		FROM {$db_prefix}boards AS b
			LEFT JOIN {$db_prefix}board_permissions AS bp ON (bp.ID_BOARD = 0 AND bp.ID_GROUP IN (" . implode(', ', $groups) . ") AND bp.permission = '$permission')
			LEFT JOIN {$db_prefix}moderators AS mods ON (mods.ID_MEMBER = $ID_MEMBER AND mods.ID_BOARD = b.ID_BOARD)
			LEFT JOIN {$db_prefix}board_permissions AS mod_bp ON (mod_bp.ID_BOARD = 0 AND mod_bp.ID_GROUP = 3 AND mod_bp.permission = '$permission')
		WHERE b.use_local_permissions = 0
</search for>

<replace>
		SELECT b.ID_BOARD, IFNULL(bp.addDeny, mod_bp.addDeny) AS addDeny
		FROM {$db_prefix}boards AS b
			LEFT JOIN {$db_prefix}board_permissions AS bp ON (bp.ID_BOARD = 0 AND bp.ID_GROUP IN (" . implode(', ', $groups) . ") AND bp.permission = '$permission')
			LEFT JOIN {$db_prefix}moderators AS mods ON (mods.ID_MEMBER = $ID_MEMBER AND mods.ID_BOARD = b.ID_BOARD)
			LEFT JOIN {$db_prefix}board_permissions AS mod_bp ON (mod_bp.ID_BOARD = 0 AND mod_bp.ID_GROUP = 3 AND mod_bp.permission = '$permission')
			LEFT JOIN {$db_prefix}member_permissions AS mp ON (mp.ID_BOARD = 0 AND mp.ID_MEMBER = $ID_MEMBER AND mp.permission = '$permission')
		WHERE b.use_local_permissions = 0
</replace>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
		while ($row = mysql_fetch_assoc($request))
		{
			if (empty($row['addDeny']))
				$removals[] = $row['permission'];
			else
				$user_info['permissions'][] = $row['permission'];
		}
		mysql_free_result($request);
</search for>

<add after>
		$request = db_query("
			SELECT permission, addDeny
			FROM {$db_prefix}member_permissions
			WHERE ID_MEMBER = $ID_MEMBER
				AND (ID_BOARD = $board OR ID_BOARD = 0)
			ORDER BY addDeny DESC, ID_BOARD", __FILE__, __LINE__);
		$remove = array();
		while ($row = mysql_fetch_assoc($request))
		{
			if (empty($row['addDeny']))
				$removals[] = $row['permission'];
			else
			{
				$user_info['permissions'][] = $row['permission'];
				// Member permissions override even a Deny!
				$remove = array_merge(array_keys($removals, $row['permission']), $remove);
			}
		}
		mysql_free_result($request);
		foreach ($remove as $key)
			unset($removals[$key]);
</add after>

<search for>
function loadPermissions()
{
	global $user_info, $db_prefix, $board, $board_info;
</search for>

<add after>
	global $ID_MEMBER;
</add after>

<search for>
	// Get the general permissions.
	$request = db_query("
		SELECT permission, addDeny
		FROM {$db_prefix}permissions
		WHERE ID_GROUP IN (" . implode(', ', $user_info['groups']) . ')', __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		if (empty($row['addDeny']))
			$removals[] = $row['permission'];
		else
			$user_info['permissions'][] = $row['permission'];
	}
	mysql_free_result($request);
</search for>

<add after>
	// Now handle the member specific ones
	$request = db_query("
		SELECT permission, addDeny
		FROM {$db_prefix}member_permissions
		WHERE ID_MEMBER = $ID_MEMBER
			AND ID_BOARD = -1
		ORDER BY addDeny", __FILE__, __LINE__);
	$remove = array();
	while ($row = mysql_fetch_assoc($request))
	{
		if (empty($row['addDeny']))
			$removals[] = $row['permission'];
		else
		{
			$user_info['permissions'][] = $row['permission'];
			// Member permissions override even a Deny!
			$remove = array_merge(array_keys($removals, $row['permission']), $remove);
		}
	}
	mysql_free_result($request);
	foreach ($remove as $key)
		unset($removals[$key]);
</add after>

<edit file>
$themedir/ManageMembers.template.php
</edit file>

<search for>
	}
	echo '
		</table><br />';
</search for>

<add after>
	echo '
		<br />
	<script language="JavaScript1.2" type="text/javascript"><!--
		function showBoxes()
		{
			if (document.getElementById("type").value == "board")
			{
				document.getElementById("general_display").style.display = "none";
				document.getElementById("board_display").style.display = "";
				document.getElementById("board_display2").style.display = "";
			}
			else
			{
				document.getElementById("general_display").style.display = "";
				document.getElementById("board_display").style.display = "none";
				document.getElementById("board_display2").style.display = "none";
			}
		}
	--></script>
<form action="', $scripturl, '?action=profile;u=', $context['member']['id'], ';sa=showPermissions" method="post">
		<table width="90%" border="0" cellspacing="1" cellpadding="4" align="center" class="tborder">
			<tr class="titlebg">
				<td width="10"><input type="checkbox" name="delete" class="check" onclick="invertAll(this, this.form);"/></td>
				<td colspan="2">', $txt['memberPermissions_general'], '</td>
			</tr>';
	if (!empty($context['member']['specific_member_permissions']))
	{
		$alternate = true;
		foreach ($context['member']['specific_member_permissions'] as $permission)
		{
			echo '
			<tr class="', $alternate ? 'windowbg2' : 'windowbg', '">
				<td width="10"><input type="checkbox" name="delete[-1][', $permission['id'], ']" class="check" /></td>
				<td colspan="2" ', $permission['denied'] ? ' style="text-decoration: line-through;"' : '', '>', $permission['name'], ' <i>(', $permission['id'], ')</i></td>
			</tr>';
			$alternate = !$alternate;
		}
	}
	else
	{
		echo '
			<tr class="windowbg2">
				<td colspan="3">', $txt['memberPermissions_none'], '</td>
			</tr>';
	}
	echo '
			<tr class="titlebg">
				<td width="10"></td>
				<td>', $txt['memberPermissions_board'], '</td>
				<td>', $txt['memberPermissions_where'], '</td>
			</tr>';
	if (!empty($context['member']['specific_board_permissions']))
	{
		$alternate = true;
		foreach ($context['member']['specific_board_permissions'] as $permission)
		{
			echo '
			<tr class="', $alternate ? 'windowbg2' : 'windowbg', '">
				<td width="10"><input type="checkbox" name="delete[', $permission['board_id'], '][', $permission['id'], ']" class="check" /></td>
				<td', $permission['denied'] ? ' style="text-decoration: line-through;"' : '', '>', $permission['name'], ' <i>(', $permission['id'], ')</i></td>
				<td>', $permission['board'], '</td>
			</tr>';
			$alternate = !$alternate;
		}
	}
	else
	{
		echo '
			<tr class="windowbg2">
				<td colspan="3">', $txt['memberPermissions_none'], '</td>
			</tr>';
	}

	echo '
			<tr class="titlebg">
				<td colspan="3" align="right">
					<input type="submit" name="conf_delete" value="', $txt['quickmod_delete_selected'], '" onclick="return confirm(\'', $txt['quickmod_confirm'], '\');" />
				</td>
			</tr>
		</table>
		<br />
		<table width="90%" border="0" cellspacing="1" cellpadding="4" align="center" class="tborder">
			<tr class="titlebg">
				<td colspan="2">', $txt['memberPermissions_add'], '</td>
			</tr>
			<tr class="windowbg">
				<td align="right">', $txt['memberPermissions_type'], ':</td>
				<td align="left">
					<select name="type" id="type" onchange="showBoxes();">
						<option value="">', $txt['memberPermissions_select'], '</option>
						<option value="general">', $txt['memberPermissions_general'], '</option>
						<option value="board">', $txt['memberPermissions_board'], '</option>
					</select>
				</td>
			</tr>
			<tr class="windowbg" id="board_display" style="display: none">
				<td align="right">', $txt['memberPermissions_board_select'], ':</td>
				<td align="left">
					<select name="board4p" id="board4p">
						<option value="">', $txt['memberPermissions_select'], '</option>
						<option value="0"><b>', $txt['memberPermissions_all'], '</b></option>';
	if (!empty($context['mems_boards']))
		foreach ($context['mems_boards'] as $curBoard)
			echo '
						<option value="', $curBoard['id'], '">', $curBoard['name'], '</option>';
	echo '
					</select>
				</td>
			</tr>
			<tr class="windowbg" id="board_display2" style="display: none">
				<td align="right">', $txt['memberPermissions_permission'], ':</td>
				<td align="left">
					<select name="bpermission" id="bpermission">
						<option value="">', $txt['memberPermissions_select'], '</option>';
	if (!empty($context['boardPerms']))
		foreach ($context['boardPerms'] as $id => $name)
			echo '
						<option value="', $id, '">', $name, '</option>';
	echo '
					</select>
				</td>
			</tr>
			<tr class="windowbg" id="general_display" style="display: none">
				<td align="right">', $txt['memberPermissions_permission'], ':</td>
				<td align="left">
					<select name="gpermission">
						<option value="">', $txt['memberPermissions_select'], '</option>';
	if (!empty($context['generalPerms']))
		foreach ($context['generalPerms'] as $id => $name)
			echo '
						<option value="', $id, '">', $name, '</option>';
	echo '
					</select>
				</td>
			</tr>
			<tr class="windowbg">
				<td align="right">', $txt['memberPermissions_state'], ':</td>
				<td align="left">
					<select name="state">
						<option value="">', $txt['memberPermissions_select'], '</option>
						<option value="1">', $txt['permissions_add'], '</option>
						<option value="0">', $txt['permissions_deny'], '</option>
					</select>
				</td>
			</tr>
			<tr class="titlebg">
				<td colspan="3"><input type="submit" name="add" value="', $txt['memberPermissions_add_but'], '"></td>
			</tr>
		</table>
	</form>';

</add after>

<edit file>
$sourcedir/ManageMembers.php
</edit file>

<search for>
				$context['member']['permissions']['board'][$row['permission']]['boards']['allowed'][$row['ID_BOARD']] = $row['name'];
		}
	}
	mysql_free_result($result);
</search for>

<add after>
	$context['member']['specific_permissions'] = array();
	$context['member']['specific_board_permissions'] = array();
	$result = db_query("
		SELECT mp.permission, mp.addDeny, mp.ID_BOARD, b.name AS boardName
		FROM {$db_prefix}member_permissions AS mp
			LEFT JOIN {$db_prefix}boards AS b ON (b.ID_BOARD = mp.ID_BOARD)
		WHERE mp.ID_MEMBER = $memID
		ORDER BY mp.addDeny DESC, mp.ID_BOARD", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($result))
	{
		// We don't know about this permission, it doesn't exist :P.
		if (!isset($txt['permissionname_' . $row['permission']]))
			continue;

		if (in_array(substr($row['permission'], -4), array('_own', '_any')) && isset($txt['permissionname_' . substr($row['permission'], 0, -4)]))
			$name = $txt['permissionname_' . substr($row['permission'], 0, -4)] . ' - ' . $txt['permissionname_' . $row['permission']];
		else
			$name = $txt['permissionname_' . $row['permission']];

		if ($row['ID_BOARD'] == -1)
			$context['member']['specific_member_permissions'][] = array(
				'id' => $row['permission'],
				'name' => $name,
				'denied' => empty($row['addDeny'])
			);
		else
			$context['member']['specific_board_permissions'][] = array(
				'id' => $row['permission'],
				'name' => $name,
				'board_id' => $row['ID_BOARD'],
				'board' => $row['ID_BOARD'] == 0 ? $txt['memberPermissions_all'] : $row['boardName'],
				'denied' => empty($row['addDeny'])
			);
	}
	mysql_free_result($result);
	// Have to load ALL possible permissiond!
	$generalPerms = array(
		'search_posts',
		'calendar_view',
		'view_stats',
		'who_view',
		'profile_view_own',
		'profile_identity_own',
		'view_mlist',
		'karma_edit',
		'pm_read',
		'pm_send',
		'profile_view_any',
		'profile_extra_own',
		'profile_remote_avatar',
		'calendar_post',
		'calendar_edit_own',
		'manage_attachments',
		'manage_smileys',
		'manage_boards',
		'moderate_forum',
		'manage_membergroups',
		'manage_bans',
		'admin_forum',
		'manage_permissions',
		'edit_news',
		'calendar_edit_any',
		'profile_identity_any',
		'profile_extra_any',
		'profile_title_any',
	);
	$boardPerms = array(
		'poll_view',
		'post_new',
		'post_reply_any',
		'remove_own',
		'modify_own',
		'mark_any_notify',
		'mark_notify',
		'report_any',
		'send_topic',
		'poll_vote',
		'poll_edit_own',
		'poll_post',
		'poll_add_own',
		'post_attachment',
		'lock_own',
		'delete_own',
		'view_attachments',
		'make_sticky',
		'poll_edit_any',
		'remove_any',
		'modify_any',
		'lock_any',
		'delete_any',
		'move_any',
		'merge_any',
		'split_any',
		'poll_lock_any',
		'poll_remove_any',
		'poll_add_any',
	);

	$context['generalPerms'] = array();
	$context['boardPerms'] = array();
	foreach ($generalPerms as $id)
	{
		// If I mess up here... just don't put egg on my face
		if (!isset($txt['permissionname_' . $id]))
			continue;

		if (in_array(substr($id, -4), array('_own', '_any')) && isset($txt['permissionname_' . substr($id, 0, -4)]))
			$name = $txt['permissionname_' . substr($id, 0, -4)] . ' - ' . $txt['permissionname_' . $id];
		else
			$name = $txt['permissionname_' . $id];
		$context['generalPerms'][$id] = $name;
	}
	foreach ($boardPerms as $id)
	{
		// If I mess up here... just don't put egg on my face
		if (!isset($txt['permissionname_' . $id]))
			continue;

		if (in_array(substr($id, -4), array('_own', '_any')) && isset($txt['permissionname_' . substr($id, 0, -4)]))
			$name = $txt['permissionname_' . substr($id, 0, -4)] . ' - ' . $txt['permissionname_' . $id];
		else
			$name = $txt['permissionname_' . $id];
		$context['boardPerms'][$id] = $name;
	}
	asort($context['generalPerms']);
	asort($context['boardPerms']);

	// Get ALL boards here - not just local ones!
	$result = db_query("
		SELECT b.ID_BOARD, b.name
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]", __FILE__, __LINE__);
	$context['mems_boards'] = array();
	while ($row = mysql_fetch_assoc($result))
		$context['mems_boards'][$row['ID_BOARD']] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['name'],
			'selected' => $board == $row['ID_BOARD']
		);
	mysql_free_result($result);
</add after>

<search for>
function showPermissions($memID)
{
	global $scripturl, $txt, $db_prefix, $board;
	global $user_profile, $context, $user_info;
</search for>

<add after>
	// They want to delete stuff?
	if (isset($_POST['conf_delete']))
	{
		if (isset($_POST['delete']))
			foreach ($_POST['delete'] as $ID_BOARD => $permissions)
			{
				foreach ($permissions as $perm => $dummy)
					db_query("
						DELETE FROM {$db_prefix}member_permissions
						WHERE ID_MEMBER = $memID
							AND ID_BOARD = $ID_BOARD
							AND permission = '$perm'", __FILE__, __LINE__);
			}
	}
	// What if they want to add a new permission? How exciting!!
	elseif (isset($_POST['add']) && $_POST['type'] != '' && $_POST['state'] != '')
	{
		$addDeny = (int) $_POST['state'];
		$boardid = $_POST['type'] == 'board' ? (int) $_POST['board4p'] : -1;
		$permission = $_POST['type'] == 'board' ? $_POST['bpermission'] : $_POST['gpermission'];
		if ($permission != '')
			db_query("
				REPLACE INTO {$db_prefix}member_permissions
					(ID_MEMBER, ID_BOARD, permission, addDeny)
				VALUES
					($memID, $boardid, '$permission', $addDeny)", __FILE__, __LINE__);
	}
	$context['member']['id'] = $memID;
</add after>

<search for>
	db_query("
		DELETE FROM {$db_prefix}themes
		WHERE ID_MEMBER $condition", __FILE__, __LINE__);
</search for>

<add after>
	db_query("
		DELETE FROM {$db_prefix}member_permissions
		WHERE ID_MEMBER $condition", __FILE__, __LINE__);
</add after>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$txt['permission_bymember'] = 'Permissions By Member';
$txt['permission_bymember_link'] = 'Click';
$txt['permission_bymember_link2'] = 'Here';
$txt['permission_bymember_link3'] = 'To Review Member Specific Permissions';
$txt['memberPermissions_general'] = 'Member Specific Permissions';
$txt['memberPermissions_board'] = 'Member Specific Board Permissions';
$txt['memberPermissions_none'] = 'This member has no member specific permissions';
$txt['memberPermissions_where'] = 'In Board';
$txt['memberPermissions_all'] = 'All Boards';
$txt['memberPermissions_add'] = 'Add New Member <b>Specific</b> Permission';
$txt['memberPermissions_type'] = 'Permission Type';
$txt['memberPermissions_general'] = 'General Permission';
$txt['memberPermissions_board'] = 'Board Permission';
$txt['memberPermissions_board_select'] = 'Select Board';
$txt['memberPermissions_permission'] = 'Select Permission';
$txt['memberPermissions_state'] = 'Permission State';
$txt['memberPermissions_select'] = 'Select:';
$txt['memberPermissions_add_but'] = 'Add';
</add before>

<edit file>
$themedir/ManagePermissions.template.php
</edit file>

<search for>
		echo '
			</table>';
	}
</search for>

<add after>
	echo '
			<table width="100%" border="0" cellpadding="3" cellspacing="1" class="tborder" style="margin-top: 2ex;">
				<tr class="catbg">
					<td style="padding: 4px;">', $txt['permission_bymember'], '</td>
				</tr><tr class="windowbg" align="center">
					<td style="padding: 4px;">', $txt['permission_bymember_link'], ' <a href="', $scripturl, '?action=permissions;sa=mspecific">', $txt['permission_bymember_link2'], '</a> ', $txt['permission_bymember_link3'], '</td>
				</tr>
			</table>';
</add after>

<search for>
function template_modify_group()
{
	global $context, $settings, $options, $scripturl, $txt;
</search for>

<add before>
function template_member_specific()
{
	global $context, $settings, $options, $scripturl, $txt;

	$alternate = 0;
	echo '
		<table width="60%" border="0" cellspacing="0" cellpadding="1" class="bordercolor" align="center"><tr><td>
			<table border="0" width="100%" cellspacing="0" cellpadding="4" class="bordercolor">
				<tr class="catbg">
					<td colspan="4" align="left">', $txt['permission_bymember'], '</td>
				</tr>
				<tr class="titlebg">
					<td align="left">', $txt[68], '</td>
					<td align="center" width="12%">', $txt['permissions_allowed'], '</td>
					<td align="center" width="12%">', $txt['permissions_denied'], '</td>
					<td></td>
				</tr>';
	foreach ($context['permissions'] as $member)
	{
		echo '
				<tr class="', $alternate ? 'windowbg' : 'windowbg2', '">
					<td align="left">', $member['name'], '</td>
					<td align="center">', $member['allow'], '</td>
					<td align="center"><font color="red">', $member['deny'], '</font></td>
					<td align="center">', $member['link'], '</td>
				</tr>';
		$alternate = !$alternate;
	}

	echo '
			</table></td></tr>
		</table>';
}
</add before>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>

<search for>
	$subActions = array(
		'quick' => 'SetQuickGroups',
</search for>

<add after>
		'mspecific' => 'SpecificPermissions',
</add after>

<search for>
function ModifyPermissions()
{
</search for>

<add before>
// Function for displaying all members with specific permissions;
function SpecificPermissions()
{
	global $context, $txt, $db_prefix, $scripturl;

	$context['sub_template'] = 'member_specific';
	$context['page_title'] = $txt['permission_bymember'];

	$context['permissions'] = array();

	// Get all the counts for allow permissions
	$request = db_query("
			SELECT COUNT(mp.permission) AS allow, mp.ID_MEMBER, mem.realName
			FROM {$db_prefix}member_permissions AS mp
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = mp.ID_MEMBER)
			WHERE mp.addDeny = 1
			GROUP BY mp.ID_MEMBER", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
		$context['permissions'][$row['ID_MEMBER']] = array(
			'name' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . ';sa=showPermissions">' . $txt['permissions_modify'] . '</a>',
			'deny' => 0,
			'allow' => $row['allow']
		);
	mysql_free_result($request);

	// Same again but for deny!
	$request = db_query("
			SELECT COUNT(mp.permission) AS deny, mp.ID_MEMBER, mem.realName
			FROM {$db_prefix}member_permissions AS mp
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = mp.ID_MEMBER)
			WHERE mp.addDeny = 0
			GROUP BY mp.ID_MEMBER", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		if (!isset($context['permissions'][$row['ID_MEMBER']]))
			$context['permissions'][$row['ID_MEMBER']] = array(
				'name' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
				'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . ';sa=showPermissions">' . $txt['permissions_modify'] . '</a>',
				'deny' => $row['deny'],
				'allow' => 0
			);
		else
			$context['permissions'][$row['ID_MEMBER']]['deny'] = $row['deny'];
	}
	mysql_free_result($request);

	obExit();
}
</add before>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
			// Delete any extra events in the calendar for this category.
			db_query("
				DELETE FROM {$db_prefix}calendar
				WHERE ID_BOARD IN (" . implode(', ', $boards) . ')', __FILE__, __LINE__);
</search for>

<add after>
			// Delete any member permissions for this
			db_query("
				DELETE FROM {$db_prefix}member_permissions
				WHERE ID_BOARD IN (" . implode(', ', $boards) . ')', __FILE__, __LINE__);
</add after>

<search for>
		// Delete any permissions associated with this board.
		db_query("
			DELETE FROM {$db_prefix}board_permissions
			WHERE ID_BOARD = $_POST[ID_BOARD]", __FILE__, __LINE__);
</search for>

<add after>
		// Delete any permissions associated with this board.
		db_query("
			DELETE FROM {$db_prefix}member_permissions
			WHERE ID_BOARD = $_POST[ID_BOARD]", __FILE__, __LINE__);
</add after>